import org.jetbrains.kotlin.gradle.dsl.KotlinVersion
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.*
import ru.landgrafhomyak.kotlin.kmp_gradle_build_helper.plugin.xomrk

buildscript {
	repositories {
		mavenCentral()
		maven("https://maven.landgrafhomyak.ru/")
	}

	dependencies {
		classpath("ru.landgrafhomyak.kotlin:kotlin-mpp-gradle-build:v0.3k2.1.10")
	}
}

group = "ru.landgrafhomyak.utility"
version = "0.1"

repositories {
	mavenCentral()
	maven("https://maven.landgrafhomyak.ru/")
}

xomrk {
	kotlin {
		setCompatibilityWithKotlin(KotlinVersion.KOTLIN_2_0)
		optInContracts()
		explicitApi()

		defineAllMultiplatformTargets()

		sourceSets {
			commonMain {
				dependencies {
					implementation("org.jetbrains.kotlinx:atomicfu:0.27.0")
					implementation("ru.landgrafhomyak.utility:highlevel-try-finally:0.5")
				}
			}
		}
	}

	publishing {
		repositories {
			defineXomrkGiteaMavenRepo()
		}
	}
}