package ru.landrafhomyak.utility.reference_counter

import kotlinx.atomicfu.AtomicLong

@Suppress("ClassName")
internal object _CloseableReferenceCounter_LowLevel {
	internal fun compareAndExchange(atomic: AtomicLong, expected: Long, newValue: Long): Long {
		while (true) {
			val old = atomic.value
			if (old != expected) return old
			if (atomic.compareAndSet(old, newValue)) return old
		}
	}

	internal const val CLOSED_STATE_VALUE = -0x4000_0000_0000_0000L
}